@echo off
rem ###########################################################################
rem ##                                                                       ##
rem ##  D B T U T O O L S / D B T U S W I T C H . B A T                      ##
rem ##                                                                       ##
rem ## --------------------------------------------------------------------- ##
rem ##                                                                       ##
rem ##  Job .......: Script for changing the environmental settings based    ##
rem ##               on the given instance name.                             ##
rem ##                                                                       ##
rem ## --------------------------------------------------------------------- ##
rem ##                                                                       ##
rem ##  Copyright (C) 2002  Daniel Scheibli                                  ##
rem ##                                                                       ##
rem ##  This program is free software; you can redistribute it and/or        ##
rem ##  modify it under the terms of the GNU General Public License as       ##
rem ##  published by the Free Software Foundation; either version 2 of       ##
rem ##  the License, or (at your option) any later version.                  ##
rem ##                                                                       ##
rem ##  This program is distributed in the hope that it will be useful,      ##
rem ##  but WITHOUT ANY WARRANTY; without even the implied warranty of       ##
rem ##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        ##
rem ##  GNU General Public License for more details.                         ##
rem ##                                                                       ##
rem ##  You should have received a copy of the GNU General Public License    ##
rem ##  along with this program; if not, write to the Free Software          ##
rem ##  Foundation, Inc., 59 Temple Place - Suite 330, Boston,               ##
rem ##  MA 02111-1307, USA.                                                  ##
rem ##                                                                       ##
rem ## --------------------------------------------------------------------- ##
rem ##                                                                       ##
rem ##  Remark ....: - Because of the different implementation of IBM DB2    ##
rem ##                 UDB for Windows and IBM DB2 UDB for Unix, the batch   ##
rem ##                 file version does a small subset of the shell script  ##
rem ##                 version only.                                         ##
rem ##               - While listing the DB2 instances, the Status as well   ##
rem ##                 as the Comment field are not filled (for the Status   ##
rem ##                 field a '-' is listed, the Comment field is black).   ##
rem ##                                                                       ##
rem ## --------------------------------------------------------------------- ##
rem ##                                                                       ##
rem ##  Author ....: Daniel Scheibli <daniel.scheibli@edelbyte.org>          ##
rem ##  Date ......: 2002-12-22                                              ##
rem ##  Changes ...: ----- dbtuswitch.bat V00.99/R020 ---------------------- ##
rem ##               <none>                                                  ##
rem ##                                                                       ##
rem ###########################################################################



rem ##### Presettings (global)
rem #--------------------------------------------------------------------------
set XX1OPTREEROOT=C:\Program Files\DbtuTools
rem #--------------------------------------------------------------------------



rem ##### Presettings
rem #--------------------------------------------------------------------------
echo.
echo DBTUSWITCH.BAT V00.99/R020
echo.
rem #--------------------------------------------------------------------------



rem ##### Process the given arguments
rem #-------------------------------------------------------------------------
set XX1ARGS=0
if not "%1" == "" set XX1ARGS=1
if not "%2" == "" set XX1ARGS=2
if not "%3" == "" set XX1ARGS=3
rem #- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
if "%XX1ARGS%" == "0" goto FuncActionList
if "%XX1ARGS%" == "1" goto FuncActionSwitch
if "%XX1ARGS%" == "2" goto FuncActionSwitch
if "%XX1ARGS%" == "3" goto FuncActionUsage
rem #-------------------------------------------------------------------------





rem ###########################################################################
rem ##                                                                       ##
rem ##   F U N C A C T I O N L I S T                                         ##
rem ##                                                                       ##
rem ###########################################################################
:FuncActionList
 rem ##### Print the list of instances
 rem #-------------------------------------------------------------------------
 echo           Instance
 echo Status    Name     Comment
 echo --------- -------- --------------------------------------------------
 for /F "Tokens=*" %%I in ('db2ilist') do echo -         %%I
 echo.
 rem #-------------------------------------------------------------------------



 rem ##### TODO: Fill the Status and Comment field (see comments below)
 rem #-------------------------------------------------------------------------
 rem # for /F "Delims=:= Tokens=2" %%I in ('type "%XX1OPTREEROOT%\dbtuswitch.cfg" ^| find "Instance=" ^| find ":Comment="') do echo %%I
 rem # for /F "Delims=:= Tokens=4-31" %%I in ('type "%XX1OPTREEROOT%\dbtuswitch.cfg" ^|  find "Instance=" ^| find ":Comment="') do echo %%I
 rem #-------------------------------------------------------------------------
goto Exit





rem ###########################################################################
rem ##                                                                       ##
rem ##   F U N C A C T I O N S W I T C H                                     ##
rem ##                                                                       ##
rem ###########################################################################
:FuncActionSwitch
 rem ##### Presettings
 rem #-------------------------------------------------------------------------
 set XX1INSTANCE=%1
 rem #------------------------------------------------------------------------- 



 rem ##### React on a keyword as instance name ("current" or "default")
 rem #-------------------------------------------------------------------------
 rem ##### On "current" keyword,...
 if "%1" == "current" (
  set XX1INSTANCE=%DB2INSTANCE%
  if "%XX1INSTANCE%" == "" (
   echo ===^> ERROR: The name of the current instance is not detectable.
   goto Exit
  )
 )
 rem #- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 rem ##### On "default" keyword,...
 if "%1" == "default" (
  for /F "Delims== Tokens=2" %%I in ('type "%XX1OPTREEROOT%\dbtuswitch.cfg" ^| find "DefaultInstance="') do set XX1INSTANCE=%%I
  if "%XX1INSTANCE%" == "" (
   echo ===^> ERROR: The configuration file contains no 'DefaultInstance' value.
   goto Exit
  )
 )
 rem #-------------------------------------------------------------------------



 rem ##### Check for the existence of the given DB2 instance
 rem #-------------------------------------------------------------------------
 set XX1FOUND=0
 for /F "Tokens=*" %%I in ('db2ilist ^| find /I "%XX1INSTANCE%"') do set XX1FOUND=1
 rem #- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 if "%XX1FOUND%" == "0" (
  echo ===^> ERROR: The given DB2 instance could not be found.
  goto Exit
 )
 rem #-------------------------------------------------------------------------



 rem ##### Set up the proper DB2 instance
 rem #-------------------------------------------------------------------------
 set DB2INSTANCE=%XX1INSTANCE%
 rem #-------------------------------------------------------------------------



 rem ##### Set up the proper DB2 node (if given)
 rem #-------------------------------------------------------------------------
 if not "%2" == "" set DB2NODE=%2
 rem #-------------------------------------------------------------------------



 rem ##### Do a terminate to ensure that there are no
 rem ##### conflicts caused by an old background process.
 rem #-------------------------------------------------------------------------
 db2 terminate 1>NUL
 rem #-------------------------------------------------------------------------



 rem ##### Modify environmental settings for DbtuTools (ease of use)
 rem #-------------------------------------------------------------------------
 set PATH=%XX1OPTREEROOT%;%XX1OPTREEROOT%\%DB2INSTANCE%\tools\bin;%PATH%
 set CLASSPATH=%XX1OPTREEROOT%\%DB2INSTANCE%\tools\bin\dbtutools.jar;%CLASSPATH%
 set DBTUTOOLSHOME=%XX1OPTREEROOT%\%DB2INSTANCE%
 rem #-------------------------------------------------------------------------



 rem ##### Announce successfull switch to the given DB2 instance
 rem #-------------------------------------------------------------------------
 if not "%2" == "" goto FuncActionSwitch_Else
  echo Switch to instance '%XX1INSTANCE%' successfully done.
  echo.
  goto FuncActionSwitch_EndIf
 :FuncActionSwitch_Else
  echo Switch to instance '%XX1INSTANCE%' and node '%2' successfully done.
  echo.
 :FuncActionSwitch_EndIf
 rem #-------------------------------------------------------------------------
goto Exit





rem ###########################################################################
rem ##                                                                       ##
rem ##   F U N C A C T I O N U S A G E                                       ##
rem ##                                                                       ##
rem ###########################################################################
:FuncActionUsage
 rem ##### Print syntax diagram
 rem #-------------------------------------------------------------------------
 echo ===^> ERROR: A minimum of one argument was expected.
 echo.
 echo Usage .......: ^>^>--- dbtuswitch.bat ---+--- INSTANCE ---+---^>
 echo                                        ^|                ^|
 echo                                        +--- default ----+ 
 echo                                        ^|                ^|
 echo                                        +--- current ----+ 
 echo.
 echo                 ^>---+-------------+-------------------------^>^<
 echo                     ^|             ^|
 echo                     +---- NODE ---+
 echo.
 echo Sample ......: dbtuswitch.bat db2inst1
 echo.
 echo Arguments ...: INSTANCE   Name of the DB2 instance to switch to or one of the
 echo                           following two keywords:
 echo                           - 'default' = Switch to the default instance - set 
 echo                                         in the %XX1OPTREEROOT%\dbtuswitch.ini
 echo                                         file.
 echo                           - 'current' = Switch to the instance named in the
 echo                                         %DB2INSTANCE% environment variable.
 echo                NODE       Node number to be set in the $DB2NODE environment
 echo                           variable.
 echo.
 rem #-------------------------------------------------------------------------
goto Exit





rem ##### End of program
rem #--------------------------------------------------------------------------
:Exit
rem #--------------------------------------------------------------------------




