@echo off
rem ###########################################################################
rem ##                                                                       ##
rem ##  D B T U T O O L S / D B T U X C O N N E C T . B A T                  ##
rem ##                                                                       ##
rem ## --------------------------------------------------------------------- ##
rem ##                                                                       ##
rem ##  Job .......: Script to establish an exclusive connection (forcing    ##
rem ##               existing connections to the database).                  ##
rem ##                                                                       ##
rem ## --------------------------------------------------------------------- ##
rem ##                                                                       ##
rem ##  Copyright (C) 2002  Daniel Scheibli                                  ##
rem ##                                                                       ##
rem ##  This program is free software; you can redistribute it and/or        ##
rem ##  modify it under the terms of the GNU General Public License as       ##
rem ##  published by the Free Software Foundation; either version 2 of       ##
rem ##  the License, or (at your option) any later version.                  ##
rem ##                                                                       ##
rem ##  This program is distributed in the hope that it will be useful,      ##
rem ##  but WITHOUT ANY WARRANTY; without even the implied warranty of       ##
rem ##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        ##
rem ##  GNU General Public License for more details.                         ##
rem ##                                                                       ##
rem ##  You should have received a copy of the GNU General Public License    ##
rem ##  along with this program; if not, write to the Free Software          ##
rem ##  Foundation, Inc., 59 Temple Place - Suite 330, Boston,               ##
rem ##  MA 02111-1307, USA.                                                  ##
rem ##                                                                       ##
rem ## --------------------------------------------------------------------- ##
rem ##                                                                       ##
rem ##  Remark ....: <none>                                                  ##
rem ##                                                                       ##
rem ## --------------------------------------------------------------------- ##
rem ##                                                                       ##
rem ##  Author ....: Daniel Scheibli <daniel.scheibli@edelbyte.org>          ##
rem ##  Date ......: 2002-12-25                                              ##
rem ##  Changes ...: ----- dbtuff2code.bat V00.99/R020 --------------------- ##
rem ##               <none>                                                  ##
rem ##                                                                       ##
rem ###########################################################################



rem ##### Presettings
rem #--------------------------------------------------------------------------
echo.
echo DBTUXCONNECT.BAT V00.99/R020
echo.
rem #--------------------------------------------------------------------------



rem ##### Process the given arguments
rem #--------------------------------------------------------------------------
if "%1" == "" (
 echo ===^> ERROR: A minimum of one argument was expected.
 echo.
 echo Usage .......: ^>^>--- dbtuxconnect.bat --- ALIAS ---^>^<
 echo.
 echo Sample ......: dbtuxconnect.bat sample
 echo.
 echo Arguments ...: ALIAS   The alias of the database the
 echo                        exclusive connection should be
 echo                        established for.
 echo.
 goto Exit
)
rem #--------------------------------------------------------------------------



rem ##### Process the given arguments
rem #--------------------------------------------------------------------------
echo Try to establish an exclusive connection to database '%1'
pause
echo.
rem #--------------------------------------------------------------------------



rem ##### Loop until connection is established
rem #--------------------------------------------------------------------------
:Connect
rem ##### Try to connect to the database
db2 CONNECT TO %1 IN EXCLUSIVE MODE
rem ##### If connection couldn't be established,...
if errorlevel 1 goto Force
rem ##### If connection was successfully established,...
goto Exit
rem #- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - --
:Force
rem ##### Force the existing connections
for /F "Tokens=3" %%I in ('db2 LIST APPLICATIONS ^| find /I "%1"') do db2 FORCE APPLICATION (%%I)
goto Connect
rem #--------------------------------------------------------------------------



rem ##### End of program
rem #--------------------------------------------------------------------------
:Exit
rem #--------------------------------------------------------------------------


