/* ######################################################################### */
/* ##                                                                     ## */
/* ##  D B T U T O O L S / D B T U T R A F F I C . J A V A                ## */
/* ##                                                                     ## */
/* ## ------------------------------------------------------------------- ## */
/* ##                                                                     ## */
/* ##  Job .......: Tool for generating different kinds of traffic        ## */
/* ##               within a given database.                              ## */
/* ##                                                                     ## */
/* ## ------------------------------------------------------------------- ## */
/* ##                                                                     ## */
/* ##  Copyright (C) 2002  Daniel Scheibli                                ## */
/* ##                                                                     ## */
/* ##  This program is free software; you can redistribute it and/or      ## */
/* ##  modify it under the terms of the GNU General Public License        ## */
/* ##  as published by the Free Software Foundation; either version 2     ## */
/* ##  of the License, or (at your option) any later version.             ## */
/* ##                                                                     ## */
/* ##  This program is distributed in the hope that it will be useful,    ## */
/* ##  but WITHOUT ANY WARRANTY; without even the implied warranty of     ## */
/* ##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the      ## */
/* ##  GNU General Public License for more details.                       ## */
/* ##                                                                     ## */
/* ##  You should have received a copy of the GNU General Public License  ## */
/* ##  along with this program; if not, write to the Free Software        ## */
/* ##  Foundation, Inc., 59 Temple Place - Suite 330, Boston,             ## */
/* ##  MA  02111-1307, USA.                                               ## */
/* ##                                                                     ## */
/* ## ------------------------------------------------------------------- ## */
/* ##                                                                     ## */
/* ##  Remark ....: <none>                                                ## */
/* ##                                                                     ## */
/* ## ------------------------------------------------------------------- ## */
/* ##                                                                     ## */
/* ##  Author ....: Daniel Scheibli <daniel.scheibli@edelbyte.org>        ## */
/* ##  Date ......: 2002-08-16                                            ## */
/* ##  Changes ...: ----- dbtutraffic.java V00.99/R020 ------------------ ## */
/* ##               2003-01-26 - Changed parameter format to be conform   ## */
/* ##                            with the dbtuapiwrapper utility.         ## */
/* ##               ----- dbtutraffic.java V00.99/R011 ------------------ ## */
/* ##               <none>                                                ## */
/* ##                                                                     ## */
/* ######################################################################### */



/* ##### Presettings */
/* ------------------------------------------------------------------------- */
package org.dbtutools.DbtuTools;
/* ------------------------------------------------------------------------- */





/* ##### Class definition */
/* ------------------------------------------------------------------------- */
public class dbtutraffic
{
 /* ######################################################################## */
 /* ##                                                                    ## */
 /* ##   < M A I N >                                                      ## */
 /* ##                                                                    ## */ 
 /* ######################################################################## */
 public static void main( java.lang.String aoArgs[] )
 {
  /* ##### Presettings */
  /* ----------------------------------------------------------------------- */
  java.lang.String    PARAM_TOKEN_DATABASE = "--database";
  java.lang.String    PARAM_TOKEN_SCHEMA   = "--schema";  
  java.lang.String    PARAM_TOKEN_CASE     = "--testcase";
  java.lang.String    PARAM_TOKEN_DEADLOCK = "deadlock";
  java.lang.String    PARAM_TOKEN_OVERFLOW = "overflow";  
  /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
  java.lang.String    oParamDbAlias        = null;
  java.lang.String    oParamDbSchema       = null;
  java.lang.String    oParamTestCase       = null;    
  /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
  int                 TESTCASE_UNKNOWN     = -1;
  int                 TESTCASE_DEADLOCK    = 1;
  int                 TESTCASE_OVERFLOW    = 2;
  /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */  
  int                 iTestCase            = TESTCASE_UNKNOWN;
  /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
  boolean             bDbConnectionFlag    = false;
  java.lang.String    oDbUrl               = null;
  java.sql.Connection oDbConnection        = null;
  /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
  int                 iCallRc;
  int                 iDummy;
  int                 I;
  /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
  int                 iProgRc = 0;
  /* ----------------------------------------------------------------------- */  



  /* ##### "Prevent nested IF's"-Loop */
  /* ----------------------------------------------------------------------- */  
  LOOP1: for(;;)
  {
   /* ##### Check the given arguments */
   /* ---------------------------------------------------------------------- */
   for(I = 0; I < aoArgs.length; I++)
   {
    /* ##### Map the given parameters based on the their total number */
    switch( aoArgs.length )
    {
     case 4:
          if( ( aoArgs[0].startsWith( PARAM_TOKEN_DATABASE ) ) &&
   	      ( aoArgs[2].startsWith( PARAM_TOKEN_CASE     ) ) )
	  {
	   oParamDbAlias  = aoArgs[1];
           oParamTestCase = aoArgs[3];
           if( oParamTestCase.compareToIgnoreCase( PARAM_TOKEN_DEADLOCK ) == 0 ) { iTestCase = TESTCASE_DEADLOCK; }
           if( oParamTestCase.compareToIgnoreCase( PARAM_TOKEN_OVERFLOW ) == 0 ) { iTestCase = TESTCASE_OVERFLOW; }
	  }
          break;
     case 6:
          if( ( aoArgs[0].startsWith( PARAM_TOKEN_DATABASE ) ) &&
   	      ( aoArgs[2].startsWith( PARAM_TOKEN_SCHEMA   ) ) &&
   	      ( aoArgs[4].startsWith( PARAM_TOKEN_CASE     ) ) )
	  {
	   oParamDbAlias  = aoArgs[1];
	   oParamDbSchema = aoArgs[3];
           oParamTestCase = aoArgs[5];
           if( oParamTestCase.compareToIgnoreCase( PARAM_TOKEN_DEADLOCK ) == 0 ) { iTestCase = TESTCASE_DEADLOCK; }
           if( oParamTestCase.compareToIgnoreCase( PARAM_TOKEN_OVERFLOW ) == 0 ) { iTestCase = TESTCASE_OVERFLOW; }
	  }
          break;
     default:
          break;
    }
   }
   /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -- */   
   if( (oParamDbAlias == null) || (oParamTestCase == null) || (iTestCase == TESTCASE_UNKNOWN) )
   {
    java.lang.System.err.println( "" );
    java.lang.System.err.println( "===> ERROR: A minimum of one argument was expected." );
    (new java.lang.Exception("Error location")).printStackTrace();
    java.lang.System.err.println( "" );
    java.lang.System.err.println( "Usage .......: >>--- dbtutraffic --- --database ALIAS -------------->" );
    java.lang.System.err.println( "" );    
    java.lang.System.err.println( "                >---+-----------------------+--- --testcase NAME ---><" );
    java.lang.System.err.println( "                    |                       |" );
    java.lang.System.err.println( "                    +--- --schema SCHEMA ---+" );
    java.lang.System.err.println( "" );        
    java.lang.System.err.println( "Sample ......: dbtutraffic --database sample \\" );
    java.lang.System.err.println( "                           --schema dbtutools \\" );
    java.lang.System.err.println( "                           --testcase deadlock" );
    java.lang.System.err.println( "" );
    java.lang.System.err.println( "Arguments ...: --database ALIAS   The alias of the database the program" );
    java.lang.System.err.println( "                                  should connect to." );
    java.lang.System.err.println( "               --schema SCHEMA    Optional schema name used to access the" );
    java.lang.System.err.println( "                                  tables within the testcase. The default" );
    java.lang.System.err.println( "                                  is the logged on userid." );
    java.lang.System.err.println( "               --testcase NAME    The name of the test case to run:" );
    java.lang.System.err.println( "                                  deadlock = Update sequence against five" );
    java.lang.System.err.println( "                                             single record (in changing" );
    java.lang.System.err.println( "                                             order) within a one transaction." );
    java.lang.System.err.println( "                                             Running multiple instances will" );
    java.lang.System.err.println( "                                             cause a lot of deadlocks." );    
    java.lang.System.err.println( "                                  overflow = Pick up (randomly) one of 10000" );    
    java.lang.System.err.println( "                                             records and extend its VARCHAR" );
    java.lang.System.err.println( "                                             field. In a little while, there" );    
    java.lang.System.err.println( "                                             are a lot of overflow records." );    
    java.lang.System.err.println( "" );
    iProgRc = 1;
    break LOOP1;
   }
   /* ---------------------------------------------------------------------- */



   /* ##### Loading JDBC drivers */
   /* ---------------------------------------------------------------------- */
   try
   { java.lang.Class.forName("COM.ibm.db2.jdbc.app.DB2Driver").newInstance(); }
   catch( java.lang.Exception oException )
   {
    java.lang.System.err.println( "" );
    java.lang.System.err.println( "===> ERROR: Loading the JDBC drivers failed." );
    oException.printStackTrace();
    java.lang.System.err.println( "" );
    iProgRc = 1;
    break LOOP1;
   }
   /* ---------------------------------------------------------------------- */



   /* ##### Establish the database connection */
   /* ---------------------------------------------------------------------- */
   oDbUrl = new java.lang.String( "jdbc:db2:" + oParamDbAlias.toString() );
   /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -- */
   try
   { oDbConnection = java.sql.DriverManager.getConnection(oDbUrl); }
   catch( java.lang.Exception oException )
   {
    java.lang.System.err.println( "" );
    java.lang.System.err.println( "===> ERROR: Connection to database couldn't be established." );   
    oException.printStackTrace();
    java.lang.System.err.println( "" );
    iProgRc = 1;
    break LOOP1;
   }
   /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -- */
   bDbConnectionFlag = true;
   /* ---------------------------------------------------------------------- */

  

   /* ##### Run the given test case */
   /* ---------------------------------------------------------------------- */
   if( iTestCase == TESTCASE_DEADLOCK ) { iCallRc = TestCase_Deadlock(oDbConnection, oParamDbSchema); }
   if( iTestCase == TESTCASE_OVERFLOW ) { iCallRc = TestCase_Overflow(oDbConnection, oParamDbSchema); }
   /* ---------------------------------------------------------------------- */  


  
   /* ##### Leave "Prevent nested IF's"-Loop */
   break LOOP1;
  }
  /* ----------------------------------------------------------------------- */    
  


  /* ##### Disconnect from database */
  /* ----------------------------------------------------------------------- */  
  if( bDbConnectionFlag == true )
  {
   try
   { oDbConnection.close(); }
   catch( java.lang.Exception oException )
   {
    java.lang.System.err.println( "" );
    java.lang.System.err.println( "===> ERROR: Disconnect from database failed." );   
    oException.printStackTrace();
    java.lang.System.err.println( "" );
    iProgRc = 1;
   }
  }
  /* ----------------------------------------------------------------------- */  



  /* ##### End of program */
  /* ----------------------------------------------------------------------- */  
  java.lang.System.exit( iProgRc );
  /* ----------------------------------------------------------------------- */  
 }





 /* ######################################################################## */
 /* ##                                                                    ## */
 /* ##   T E S T C A S E _ D E A D L O C K                                ## */
 /* ##                                                                    ## */ 
 /* ######################################################################## */
 private static int TestCase_Deadlock( java.sql.Connection oParamDbConnection,
                                       java.lang.String    oParamDbTableSchema )                                       
 {
  /* ##### Presettings */
  /* ----------------------------------------------------------------------- */
  java.util.Random           oRandomizer = new java.util.Random();
  boolean                    oOrder;
  int                        iRowId;
  /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
  java.sql.PreparedStatement oDbStatement = null;
  java.lang.String           oDbHostVariableValue;
  int                        oDbHostVariableRowId;
  boolean                    bDbCommitFlag;
  /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
  java.lang.String           oDummy;
  long                       lDummy;
  int                        iDummy;
  int                        I;
  /* ----------------------------------------------------------------------- */



  /* ##### Setup database connection */
  /* ----------------------------------------------------------------------- */  
  java.lang.System.out.print( "Setup database connection ...   " );
  /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */  
  try
  {
   oParamDbConnection.setAutoCommit( false );
   oParamDbConnection.setTransactionIsolation( java.sql.Connection.TRANSACTION_READ_COMMITTED );
  }
  catch( java.lang.Exception oException )
  {
   java.lang.System.err.println( "" );
   java.lang.System.err.println( "===> Setting up the database connection failed." );
   oException.printStackTrace();
   java.lang.System.err.println( "" );
   return( 1 );
  }
  /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */  
  java.lang.System.out.println( "RC = 0" );  
  /* ----------------------------------------------------------------------- */  



  /* ##### Prepare the database statement */
  /* ----------------------------------------------------------------------- */  
  java.lang.System.out.print( "Prepare database statement ...   " );
  /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */  
  try
  {
   oDummy = "UPDATE " +
            ((oParamDbTableSchema != null) ? (oParamDbTableSchema.toString() + ".") : "") + "dbtutraffic01 " +
            "SET value = ? " +
	    "WHERE rowid = ?";
   oDbStatement = oParamDbConnection.prepareStatement( oDummy );
  }
  catch( java.lang.Exception oException )
  {
   java.lang.System.err.println( "" );
   java.lang.System.err.println( "===> Preparation of the statements failed." );   
   oException.printStackTrace();
   java.lang.System.err.println( "" );
   return( 1 );
  }
  /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */  
  java.lang.System.out.println( "RC = 0" );  
  /* ----------------------------------------------------------------------- */  



  /* ##### Loop forever */
  /* ----------------------------------------------------------------------- */  
  LOOP1: for(;;)
  {
   /* ##### Presettings */
   /* ---------------------------------------------------------------------- */
   oOrder = oRandomizer.nextBoolean();
   if( oOrder == true )
   { oDbHostVariableValue = "descending"; }
   else
   { oDbHostVariableValue = "ascending"; }
   /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -- */   
   bDbCommitFlag = true;
   /* ---------------------------------------------------------------------- */   



   /* ##### Wait some seconds, making deadlocks seldom */
   /* ---------------------------------------------------------------------- */
   java.lang.System.out.println( "Sleep for some milliseconds (max 50 msecs) ..." );
   /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -- */       
   lDummy = java.lang.Math.abs( oRandomizer.nextLong() % 50 );
   try
   { java.lang.Thread.sleep( lDummy ); }
   catch( java.lang.InterruptedException oException )
   { /* nop */; }
   /* ---------------------------------------------------------------------- */   
   
   

   /* ##### Loop over the 5 records in the table */
   /* ---------------------------------------------------------------------- */   
   LOOP2: for( I = 1; I <= 5; I++ )
   {
    /* ##### Set the row id (based on the processing order) */
    /* --------------------------------------------------------------------- */
    if( oOrder == true )
    { oDbHostVariableRowId = ( 5 - I + 1 ); }
    else
    { oDbHostVariableRowId = I; }
    /* --------------------------------------------------------------------- */



    /* ##### Execute the database statement */
    /* --------------------------------------------------------------------- */
    java.lang.System.out.print( "Update statement (RowId = " + oDbHostVariableRowId + ") ...   " );
    /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */  
    try
    {
     oDbStatement.setString( 1, oDbHostVariableValue );
     oDbStatement.setInt( 2, oDbHostVariableRowId );
     oDbStatement.executeUpdate();
    }
    catch( java.sql.SQLException oException )
    {
     iDummy = oException.getErrorCode();
     switch( iDummy )
     {
      case -911: /* ##### Lock timeout / deadlock,... */
           java.lang.System.out.println( "RC = " + iDummy );
           oException.printStackTrace();
           java.lang.System.err.println( "" );
           bDbCommitFlag = false;
           break LOOP2;
      default:   /* ##### Other errors,... */
           java.lang.System.out.println( "RC = " + iDummy );
           java.lang.System.err.println( "===> Update statements failed." );   
           oException.printStackTrace();
           java.lang.System.err.println( "" );
           return( 1 );
     }	   
    }
    /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */  
    java.lang.System.out.println( "RC = 0" );  
    /* --------------------------------------------------------------------- */
   }
   /* ---------------------------------------------------------------------- */   



   /* ##### Commit work */
   /* ---------------------------------------------------------------------- */  
   try
   {
    if( bDbCommitFlag )
    {
     java.lang.System.out.print( "Commit work ...   " );
     oParamDbConnection.commit();
    }
    else
    {
     java.lang.System.out.print( "Rollback work ...   " );    
     oParamDbConnection.rollback();
    }
   }
   catch( java.lang.Exception oException )
   {
    java.lang.System.err.println( "" );
    java.lang.System.err.println( "===> Commit/Rollback failed." );   
    oException.printStackTrace();
    java.lang.System.err.println( "" );
    return( 1 );
   }
   java.lang.System.out.println( "RC = 0" );
   /* ---------------------------------------------------------------------- */  
  }
  /* ----------------------------------------------------------------------- */    
 }





 /* ######################################################################## */
 /* ##                                                                    ## */
 /* ##   T E S T C A S E _ O V E R F L O W                                ## */
 /* ##                                                                    ## */ 
 /* ######################################################################## */
 private static int TestCase_Overflow( java.sql.Connection oParamDbConnection,
                                       java.lang.String    oParamDbTableSchema )                                       
 {
  /* ##### Presettings */
  /* ----------------------------------------------------------------------- */
  java.util.Random           oRandomizer = new java.util.Random();
  /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
  java.sql.PreparedStatement oDbStatementSelect = null;
  java.sql.PreparedStatement oDbStatementInsert = null;  
  java.sql.PreparedStatement oDbStatementUpdate = null;  
  java.sql.ResultSet         oDbResultSet;    
  java.lang.String           oDbHostVariableValue;
  int                        oDbHostVariableRowId;
  boolean                    bDbCommitFlag;
  /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
  java.lang.String           oDummy;
  long                       lDummy;
  int                        iDummy;
  int                        I;
  /* ----------------------------------------------------------------------- */



  /* ##### Setup database connection */
  /* ----------------------------------------------------------------------- */  
  java.lang.System.out.print( "Setup database connection ...   " );
  /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */  
  try
  {
   oParamDbConnection.setAutoCommit( false );
   oParamDbConnection.setTransactionIsolation( java.sql.Connection.TRANSACTION_READ_COMMITTED );
  }
  catch( java.lang.Exception oException )
  {
   java.lang.System.err.println( "" );
   java.lang.System.err.println( "===> Setting up the database connection failed." );
   oException.printStackTrace();
   java.lang.System.err.println( "" );
   return( 1 );
  }
  /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */  
  java.lang.System.out.println( "RC = 0" );  
  /* ----------------------------------------------------------------------- */  



  /* ##### Prepare the database statement */
  /* ----------------------------------------------------------------------- */  
  java.lang.System.out.print( "Prepare database statement ...   " );
  /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */  
  try
  {
   oDummy = "SELECT value FROM " +
            ((oParamDbTableSchema != null) ? (oParamDbTableSchema.toString() + ".") : "") + "dbtutraffic02 " +
            "WHERE rowid = ? ";
   oDbStatementSelect = oParamDbConnection.prepareStatement( oDummy, java.sql.ResultSet.TYPE_FORWARD_ONLY, java.sql.ResultSet.CONCUR_READ_ONLY );
   oDummy = "INSERT INTO " +
            ((oParamDbTableSchema != null) ? (oParamDbTableSchema.toString() + ".") : "") + "dbtutraffic02 " +
	    "VALUES ( ?, default, ?)";
   oDbStatementInsert = oParamDbConnection.prepareStatement( oDummy );
   oDummy = "UPDATE " +
            ((oParamDbTableSchema != null) ? (oParamDbTableSchema.toString() + ".") : "") + "dbtutraffic02 " +
	    "SET value = ? "+
            "WHERE rowid = ? ";
   oDbStatementUpdate = oParamDbConnection.prepareStatement( oDummy );
  }
  catch( java.sql.SQLException oException )  
  {
   iDummy = oException.getErrorCode();
   java.lang.System.out.println( "RC = " + iDummy );
   java.lang.System.err.println( "===> Preparation of the statements failed." );   
   oException.printStackTrace();
   java.lang.System.err.println( "" );
   return( 1 );
  }
  /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */  
  java.lang.System.out.println( "RC = 0" );  
  /* ----------------------------------------------------------------------- */  



  /* ##### Loop forever */
  /* ----------------------------------------------------------------------- */  
  LOOP1: for(;;)
  {
   /* ##### Presettings */
   /* ---------------------------------------------------------------------- */
   oDbHostVariableRowId = java.lang.Math.abs( oRandomizer.nextInt() % 10000 );
   /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -- */   
   bDbCommitFlag = true;
   /* ---------------------------------------------------------------------- */   



   /* ##### Process the select statement */
   /* ---------------------------------------------------------------------- */ 
   java.lang.System.out.print( "Select statement " + "(RowId = " + oDbHostVariableRowId + ") ...   " );
   oDbHostVariableValue = null;
   /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -- */
   try
   {
    oDbStatementSelect.setInt( 1, oDbHostVariableRowId );
    oDbResultSet = oDbStatementSelect.executeQuery();
    while( oDbResultSet.next() )
    { oDbHostVariableValue = oDbResultSet.getString( "VALUE" ); }
    oDbResultSet.close();
   }
   catch( java.sql.SQLException oException )
   {
    iDummy = oException.getErrorCode();
    switch( iDummy )
    {
     case 100: /* ##### Empty result set,... */
          break;
     default:   /* ##### Other errors,... */
          java.lang.System.out.println( "RC = " + iDummy);
          java.lang.System.err.println( "===> Select statements failed." );   
          oException.printStackTrace();
          java.lang.System.err.println( "" );
           return( 1 );
    }
   }
   /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -- */
   if( oDbHostVariableValue == null )
   { java.lang.System.out.println( "RC = 100" ); }
   else
   { java.lang.System.out.println( "RC = 0" ); }
   /* ---------------------------------------------------------------------- */ 



   /* ##### Insert row into database (initial phase) */
   /* ---------------------------------------------------------------------- */
   if( oDbHostVariableValue == null )
   {
    java.lang.System.out.print( "Insert statement " + "(RowId = " + oDbHostVariableRowId + ") ...   " );
    oDbHostVariableValue = "1234567890";
    /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
    try
    {
     oDbStatementInsert.setInt( 1, oDbHostVariableRowId );
     oDbStatementInsert.setString( 2, oDbHostVariableValue );
     oDbStatementInsert.executeUpdate();
    }
    catch( java.sql.SQLException oException )
    {
     iDummy = oException.getErrorCode();
     java.lang.System.out.println( "RC = " + iDummy );
     java.lang.System.err.println( "===> Insert statements failed." );   
     oException.printStackTrace();
     java.lang.System.err.println( "" );
     return( 1 );
    }
    /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
    java.lang.System.out.println( "RC = 0" );
    oDbHostVariableValue = null;
   }
   /* ---------------------------------------------------------------------- */



   /* ##### Update row in database (fragmentation phase) */
   /* ---------------------------------------------------------------------- */
   if( oDbHostVariableValue != null )
   {
    oDbHostVariableValue = oDbHostVariableValue.concat( "1234567890" );
    if( oDbHostVariableValue.length() >= 3000 )
    { oDbHostVariableValue = oDbHostVariableValue.substring( 0, 10 ); }
    java.lang.System.out.print( "Update statement (RowId = " + oDbHostVariableRowId + "; Length = " + oDbHostVariableValue.length() + ") ...   " );
    /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
    try
    {
     oDbStatementUpdate.setString( 1, oDbHostVariableValue );
     oDbStatementUpdate.setInt( 2, oDbHostVariableRowId );
     oDbStatementUpdate.executeUpdate();
    }
    catch( java.sql.SQLException oException )
    {
     iDummy = oException.getErrorCode();
     java.lang.System.out.println( "RC = " + iDummy );
     java.lang.System.err.println( "===> Update statements failed." );   
     oException.printStackTrace();
     java.lang.System.err.println( "" );
     return( 1 );
    }
    /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
    java.lang.System.out.println( "RC = 0" );  
   }
   /* ---------------------------------------------------------------------- */



   /* ##### Commit work */
   /* ---------------------------------------------------------------------- */  
   try
   {
    if( bDbCommitFlag )
    {
     java.lang.System.out.print( "Commit work ...   " );
     oParamDbConnection.commit();
    }
    else
    {
     java.lang.System.out.print( "Rollback work ...   " );    
     oParamDbConnection.rollback();
    }
   }
   catch( java.lang.Exception oException )
   {
    java.lang.System.err.println( "" );
    java.lang.System.err.println( "===> Commit/Rollback failed." );   
    oException.printStackTrace();
    java.lang.System.err.println( "" );
    return( 1 );
   }
   java.lang.System.out.println( "RC = 0" );
   /* ---------------------------------------------------------------------- */  
  }
  /* ----------------------------------------------------------------------- */    
 }
}
/* ------------------------------------------------------------------------- */




